class GameUnit
{
public:
    unsigned short health, healthMax;
    unsigned short mana, manaMax;

    GameUnit( unsigned short healthMax, unsigned short manaMax) : healthMax(healthMax), manaMax(manaMax)
    {
        health = healthMax;
        mana = manaMax;
    }

    virtual void onDeath()
    {
    }

    bool isDead()
    {
        return health == 0;
    }

    void replenish(unsigned short healthAmount, unsigned short manaAmount)
    {
        if (isDead())
            return;
        signed short newAmount = health + healthAmount;
        if (newAmount <= 0)
        {
            health = 0;
            onDeath();
        }
        else if (newAmount > healthMax)
            health = healthMax;
        else
            health = newAmount;
        newAmount = mana + manaAmount;
        if (newAmount <= 0)
            mana = 0;
        else if (newAmount > manaMax)
            mana = manaMax;
        else
            mana = newAmount;
    }
};